<?php

namespace wbb\system\event\listener;

use wbb\data\post\Post;
use wbb\data\post\PostAction;
use wbb\page\ThreadPage;
use wcf\system\event\listener\IParameterizedEventListener;
use wcf\system\push\PushPlusPlusHandler;

/**
 * @author    Olaf Braun
 * @copyright 2013-2018 Olaf Braun - Software Development
 * @license   WBB-Elite.de License <https://lizenz.wbb-elite.de/lizenz.html>
 * @package   de.wbb-elite.pushXX.board
 * @category  Push++ WBB4.1
 */
class PushPlusPlusThreadListener implements IParameterizedEventListener {
	
	/**
	 * @inheritdoc
	 */
	public function execute($eventObj, $className, $eventName, array &$parameters) {
		if ($eventObj instanceof ThreadPage) {
			PushPlusPlusHandler::getInstance()->registerEvent("thread", $eventObj->threadID);
			PushPlusPlusHandler::getInstance()->registerEvent("postUpdate", $eventObj->threadID);
		} else if ($eventObj instanceof PostAction) {
			if ($eventObj->getActionName() == "triggerPublication") {
				foreach ($eventObj->getObjects() as $post) {
					/** @var Post $post */
					PushPlusPlusHandler::getInstance()->sendMessage("de.wbb-elite.push++.notification.thread", "thread", [$post->threadID], null, [
						"body" => strip_tags($post->getMessage())
					]);
				}
			}else if ($eventObj->getActionName() == "save") {
				$post = new Post($eventObj->post->postID); //reload post
				PushPlusPlusHandler::getInstance()->sendMessage("de.wbb-elite.push++.notification.thread.update", "postUpdate", [$eventObj->thread->threadID], null, [
					"postID" => $eventObj->post->postID,
					"body" => strip_tags($post->getMessage())
				]);
			}
		}
	}
}
